//+------------------------------------------------------------------+
//|                                                           %r mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-station.com"
#property link      "www,forex-station.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     clrRoyalBlue
#property indicator_minimum    -105
#property indicator_maximum    5
#property strict

extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;    // Time frame
extern int             WprPeriod   = 14;                // Wpr period
extern bool            Interpolate = true;              // Interpolate in multi time frame mode?

double wpr[],count[];
string indicatorFileName;
#define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,WprPeriod,_buff,_y)

//
//
//
//
//

int OnInit()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,wpr);     SetIndexStyle(0,DRAW_LINE); 
   SetIndexBuffer(1,count);
   
   indicatorFileName = WindowExpertName();
   TimeFrame         = MathMax(TimeFrame,_Period);

   IndicatorShortName(timeFrameToString(TimeFrame)+" WPR ("+(string)WprPeriod+")");
return(INIT_SUCCEEDED);
}
void OnDeinit(const int reason) {  }
  
//+------------------------------------------------------------------+
//| Williams? Percent Range                                          |
//+------------------------------------------------------------------+
//
//

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& btime[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   int i,counted_bars=prev_calculated;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(rates_total-counted_bars,rates_total-1); count[0]=limit;
            if (TimeFrame!=_Period)
            {
               limit = (int)fmax(limit,fmin(rates_total-1,_mtfCall(1,0)*TimeFrame/_Period));
               for (i=limit;i>=0 && !_StopFlag; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     wpr[i] = _mtfCall(0,y);
                 
                     //
                     //
                     //
                     //
                     //
                     
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                        #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                        int n,k; datetime time = iTime(NULL,TimeFrame,y);
                           for(n = 1; (i+n)<rates_total && Time[i+n] >= time; n++) continue;	
                           for(k = 1; k<n && (i+n)<rates_total && (i+k)<rates_total; k++) _interpolate(wpr);                                                    
              }      
   return(rates_total);
   }
   
   //
   //
   //
   //
   //
    
   for (i=limit; i>=0; i--)
   { 
       double hi = High[iHighest(NULL,0,MODE_HIGH,WprPeriod,i)];
       double lo =  Low[iLowest(NULL, 0,MODE_LOW, WprPeriod,i)];
       wpr[i] = (hi!=lo) ? -100*(hi-Close[i])/(hi-lo) : 0;
   }
return(rates_total);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

